#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <..\bl_files.h>
#include <..\bl_vars.h>
#include <..\bl_graph.h>
#include <process.h>
#include "bl_svga.h"
#include "lzwlib.h"

void lzw_decompress(unsigned char rfname,unsigned char *filename,unsigned char *outfilename)
  {
      unsigned int fsize,fofs,dsize;
      int outf,rf,errorcode;
      unsigned char *lzw_inbuf,*lzw_outbuf;

      if (!strcmp(rfname,resfilename))
        rf=resfile;
      else
        rf = open(rfname, O_RDONLY);
      if (!rf) return;

      fofs=findfile(rf,filename,&fsize);
      if (!fofs) return;

      lseek(rf,fofs,SEEK_SET);
      
      lzw_inbuf = (unsigned char *)calloc(fsize,1);
      if (!lzw_inbuf) return;
      
      _dos_read(rf,lzw_inbuf,fsize,1);
      
      dsize = lzwGetDecompressedSize(lzw_inbuf);
      //fprintf(logfile,"%d",ltoa(dsize,buf,10));

      lzw_outbuf = (unsigned char *)calloc(dsize,1);
      if (!lzw_outbuf)
        {
            free(lzw_inbuf);
            return;
        }
        

      errorcode = lzwDecompress(lzw_inbuf,fsize,lzw_outbuf);
      if (!errorcode)
        {
           outf = creat(outfilename,S_IWRITE);
           _dos_write(outf,lzw_outbuf,dsize,NULL);
           close(outf);
        }

      free(lzw_inbuf);
      free(lzw_outbuf);
      if (rf!=resfile) close(rf);
  }

void extract_file(unsigned char *rfname,unsigned char *filename)
  {
      int outf,rf;
      unsigned long NumRead,NumWritten,Total,
                    fofs,fsize;

      if (!strcmp(rfname,resfilename))
        rf=resfile;
      else
        rf = open(rfname, O_RDONLY);
      if (!rf) return;
      
      outf = creat(filename,S_IWRITE);

      Total=0;

      fofs=findfile(rf,filename,&fsize);
      if (fofs==NULL) return;
      lseek(rf,fofs,SEEK_SET);
      
      do
        {
            if (fsize-Total>2048)  NumRead=2048;
             else NumRead=fsize-Total;
            _dos_read(rf,filebuf,NumRead,&NumRead);
            _dos_write(outf,filebuf,NumRead,&NumWritten);
            Total+=NumWritten;
        }
      while((Total<fsize));
      close(outf);
      if (rf!=resfile) close(rf);
  }

void copy_file(unsigned char *scr,unsigned char *dest)
  {
      int inf,outf;
      unsigned long NumRead,NumWritten,Total;

      inf = open(scr, O_RDONLY);
      if (!inf) return;
      outf = creat(dest,S_IWRITE);


      Total=0;
      do
        {
            _dos_read(inf,filebuf,2048,&NumRead);
            _dos_write(outf,filebuf,NumRead,&NumWritten);
            Total+=NumWritten;
        }
      while((NumRead!=0) && (NumRead==NumWritten));
      close(inf); close(outf);
  }
void launch_script(unsigned char *scriptname)
  {
      unsigned char str1[64],str2[64],i,sprtransp,sr,sg,sb;
      unsigned short sprx,spry;
      unsigned char prms[6][16];
      
      str1[0]='[';
      for (i=0;i<=strlen(scriptname);i++)
         str1[i+1]=scriptname[i];
      str1[i]=']'; str1[i+1]=NULL;
      
      lseek(inifile,0,SEEK_SET);

      do freadword(inifile); while (strcmp(rwstring,str1));

      do
        {
            freadword(inifile);

            if (!strcmp(rwstring,"defmenu")) //load menu
              {

                  nm=nl=ns=0;

                  do
                   {
                       freadword(inifile);

                       if (isdebug) printf("%s ",rwstring);

                       if (!strcmp(rwstring,"background"))
                        {
                            freadword(inifile);
                            if (isdebug) printf("%s \n",rwstring);
                            loadbkgrnd(rwstring,menubackgrnd);
                            continue;
                        }

                       if (!strcmp(rwstring,"rootmenu"))
                        {
                            freadword(inifile);
                            strcpy(rootmenu,rwstring);
                            if (isdebug) printf("%s \n",rwstring);
                            continue;
                        }

                       if (!strcmp(rwstring,"msprite"))
                        {
                            freadword(inifile);
                            sprites[ns].x=atoi(rwstring);
                            freadword(inifile);
                            sprites[ns].y=atoi(rwstring);           
                            freadword(inifile);
                            strcpy(sprites[ns].sprname,rwstring);
                            sprites[ns].sprtype='s';
                            if (isdebug) printf("%d %d %s\n",sprites[ns].x,sprites[ns].y,
                               sprites[ns].sprname);
                            ns++;
                            continue;
                        }
                       if (!strcmp(rwstring,"mspritet"))
                        {
                            freadword(inifile);
                            sprites[ns].x=atoi(rwstring);
                            freadword(inifile);
                            sprites[ns].y=atoi(rwstring);
                            freadword(inifile);
                            sprites[ns].transp=atoi(rwstring);           
                            freadword(inifile);
                            strcpy(sprites[ns].sprname,rwstring);
                            sprites[ns].sprtype='t';
                            if (isdebug) printf("%d %d %s\n",sprites[ns].x,sprites[ns].y,
                               sprites[ns].sprname);
                            ns++;
                            continue;
                        }
                       if (!strcmp(rwstring,"label"))
                        {
                            freadword(inifile);
                            texts[nl].x=atoi(rwstring);
                            freadword(inifile);
                            texts[nl].y=atoi(rwstring);
                            freadword(inifile);
                            texts[nl].r=atoi(rwstring);
                            freadword(inifile);
                            texts[nl].g=atoi(rwstring);
                            freadword(inifile);
                            texts[nl].b=atoi(rwstring);              
                            freadword(inifile);
                            strcpy(texts[nl].text,rwstring);
                            if (isdebug) printf("%d %d %d %d %d %s\n",texts[nl].x,texts[nl].y,
                            texts[nl].r,texts[nl].g,texts[nl].b,texts[nl].text);
                            nl++;
                            continue;
                        }
                       if (!strcmp(rwstring,"menu"))
                        {
                            freadword(inifile);
                            menus[nm].x=atoi(rwstring);
                            freadword(inifile);
                            menus[nm].y=atoi(rwstring);
                            freadword(inifile);
                            menus[nm].r=atoi(rwstring);
                            freadword(inifile);
                            menus[nm].g=atoi(rwstring);
                            freadword(inifile);
                            menus[nm].b=atoi(rwstring);
                            freadword(inifile);
                            strcpy(menus[nm].text,rwstring);
                            freadword(inifile);
                            strcpy(menus[nm].script,rwstring);
                            if (isdebug) printf("%d %d %d %d %d %s %s\n",menus[nm].x,menus[nm].y,
                            menus[nm].r,menus[nm].g,menus[nm].b,menus[nm].text,menus[nm].script);
                            nm++;
                            continue;
                        }
                   } while (strcmp(rwstring,"endmenu"));
                   drawmenu();
                   continue;

              }

            if (!strcmp(rwstring,"script")) //run script
              {
                  do
                    {
                        freadword(inifile);
                        
                        if (isdebug) printf("%s ",rwstring);
                        
                        if (!strcmp(rwstring,"rename"))
                         {
                             freadword(inifile);
                             strcpy(str1,rwstring);
                             freadword(inifile);
                             rename(str1,rwstring);
                             continue;
                         }
                        if (!strcmp(rwstring,"delete"))
                         {
                             freadword(inifile);
                             remove(rwstring);
                             continue;
                         }
                        if (!strcmp(rwstring,"copy"))
                         {
                             freadword(inifile);
                             strcpy(str1,rwstring);
                             freadword(inifile);
                             copy_file(str1,rwstring);
                             continue;
                         }
                        if (!strcmp(rwstring,"extract"))
                         {
                             freadword(inifile);
                             strcpy(str1,rwstring);
                             freadword(inifile);
                             extract_file(str1,rwstring);
                             continue;
                         }
                        if (!strcmp(rwstring,"lzw_decompress"))
                         {
                             freadword(inifile);
                             strcpy(str1,rwstring);
                             freadword(inifile);
                             strcpy(str2,rwstring);
                             freadword(inifile);
                             lzw_decompress(str1,str2,rwstring);
                             continue;
                         }
                        if (!strcmp(rwstring,"sprite"))
                         {
                             freadword(inifile);
                             sprx = atol(rwstring);
                             freadword(inifile);
                             spry = atol(rwstring);
                             freadword(inifile);
                             draw_sprite(sprx,spry,rwstring);
                             FlipPages();
                             continue;
                         }
                        if (!strcmp(rwstring,"spritet"))
                         {
                             freadword(inifile);
                             sprx = atol(rwstring);
                             freadword(inifile);
                             spry = atol(rwstring);
                             freadword(inifile);
                             sprtransp = atol(rwstring);
                             freadword(inifile);
                             draw_spritet(sprx,spry,rwstring,sprtransp);
                             FlipPages();
                             continue;
                         }
                        if (!strcmp(rwstring,"spritea"))
                         {
                             freadword(inifile);
                             sprx = atol(rwstring);
                             freadword(inifile);
                             spry = atol(rwstring);
                             freadword(inifile);
                             sr = atol(rwstring);
                             freadword(inifile);
                             sg = atol(rwstring);
                             freadword(inifile);
                             sb = atol(rwstring);
                             freadword(inifile);
                             draw_spritea(sprx,spry,rwstring,sr,sg,sb);
                             FlipPages();
                             continue;
                         }
                        if (!strcmp(rwstring,"execute"))
                         {
                             memset(prms,NULL,6*16);
                             freadword(inifile);
                             strcpy(str1,rwstring);
                             i=0;
                             freadword(inifile);
                             while (strcmp(rwstring,"NULL"))
                              {
                                  strcpy(prms[i],rwstring);
                                  i++;
                                  freadword(inifile);
                              }
                             __asm
                               {
                                   mov ax,3;
                                   int 0x10;
                               }
                             spawnl(P_WAIT,str1,prms[0],prms[1],prms[2],prms[3],prms[4],prms[5],NULL);
                             init_svga640x480x16();
                             continue;
                         }
                       if (!strcmp(rwstring,"sleep"))
                         {
                             freadword(inifile);
                             sleep(atol(rwstring));
                         }
                   } while (strcmp(rwstring,"endscript") && !eof(inifile));
              }
        }
      while (strcmp(rwstring,"fend") && (rwstring[0]!='['));
  }


